Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/Styling.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/Styling.js	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/Styling.js	(revision 9166)
@@ -33,6 +33,153 @@
             show: true,
             placement: 'outsideGrid'
+        },
+        highlighter: {
+            show: true,
+            sizeAdjust: 7.5
         }
     });
+}
+
+function handleDatatableSelectionChanged(datatable, datarow) {
+    $.ajax({
+        url: '/chart/GetDatatableContent?datatable=' + datatable + '&datarow=' + datarow,
+
+        success: function (result) {
+            var plot = generatePlot('dataTableGraph', result)
+            plot.replot({ resetAxes: true });
+
+            var resizer = $("#dataTableGraph").closest('.resizable');
+            $(resizer).unbind('resizestop');
+            $(resizer).bind('resizestop', function (event, ui) {
+                var id = $(this).children('div').get(0).id;
+                $("#dataTableGraph").height($(this).height() * 0.96);
+                $("#dataTableGraph").width($(this).width() * 0.96);
+                plot.replot({ resetAxes: true });
+            });
+        },
+        error: function (jqXHR, textStatus, errorThrown) {
+            alert(textStatus);
+        }
+    });
+}
+
+function redrawAccordions() {
+    $(".collapsible").accordion("refresh");
+}
+
+function injectDatatableAnalyzer() {
+    var datatable = null;
+    var row = null;
+
+    // crawl datatables for current run results
+    if ($("#dataTable").length > 0) {
+        $.ajax({
+            url: '/chart/GetDatatables',
+
+            success: function (result) {
+                $("#dataTable").empty();
+                $.each(result.Datatables, function (index, tableName) {
+                    // http://stackoverflow.com/questions/1801499/how-to-change-options-of-select-with-jquery
+                    $("#dataTable").append($("<option></option>").attr("value", tableName).text(tableName));
+                });
+
+                // select first row
+                // http://stackoverflow.com/questions/1414276/how-to-make-first-option-of-select-selected-with-jquery
+                $("#dataTable").val($("#dataTable option:first").val());
+                // fire selection changed event
+                $("#dataTable").change();
+            },
+            error: function (jqXHR, textStatus, errorThrown) {
+                alert(textStatus);
+            }
+        });
+
+        $("#dataTable option:selected").each(function () {
+            datatable = $(this).text();
+        });
+
+        $("#dataTable").change(function () {
+            $("#dataTable option:selected").each(function () {
+                datatable = $(this).text();
+                $.ajax({
+                    url: '/chart/GetRowNames?datatable=' + datatable,
+
+                    success: function (result) {
+                        $("#dataRow").empty();
+                        $.each(result.RowNames, function (index, rowName) {
+                            // http://stackoverflow.com/questions/1801499/how-to-change-options-of-select-with-jquery
+                            $("#dataRow").append($("<option></option>").attr("value", rowName).text(rowName));
+                        });
+
+                        // select first row
+                        // http://stackoverflow.com/questions/1414276/how-to-make-first-option-of-select-selected-with-jquery
+                        $("#dataRow").val($("#dataRow option:first").val());
+                        // fire selection changed event
+                        //$("#dataRow").change();
+                    },
+                    error: function (jqXHR, textStatus, errorThrown) {
+                        alert(textStatus);
+                    }
+                });
+            });
+        });
+
+        $("#dataRow").change(function () {
+            $("#dataRow option:selected").each(function () {
+                row = $(this).text();
+                handleDatatableSelectionChanged(datatable, row);
+            });
+        });
+    }
+}
+
+function injectMatrixGraph() {
+    $(".matrix-graph").each(function (i) {
+        var tabable = $(this).closest(".tabable");
+        var id = this.id;
+        var resizerId = $(this).parent().get(0).id;
+        var indices = retrieveMatrix(id);
+        var graphCreated = false;
+
+        $(tabable).bind('tabsactivate', function (event, ui) {
+            if ($(ui.newPanel[0]).hasClass("resizable") && !graphCreated) {
+                graphCreated = true;
+                var id = $(ui.newPanel[0]).children("div")[0].id;
+                var resizerId = $("#" + id).parent().get(0).id;
+                var indices = retrieveMatrix(id);
+
+                $.ajax({
+                    url: '/Chart/GetMatrixContentForGraph?run=' + indices.runId + '&parameterOffset=' + indices.parameterOffset + "&showMarker=false",
+
+                    success: function (result) {
+                        var plot = generatePlot(id, result);
+                        tabable.bind('tabsshow', function (event, ui) {
+                            if (ui.index == 1 && plot._drawCount == 0) {
+                                plot.replot();
+                            }
+                            redrawAccordions();
+                        });
+                        var resizer = $("#" + id).closest('.resizable');
+                        $(resizer).bind('resizestop', function (event, ui) {
+                            var id = $(this).children('div').get(0).id;
+                            $("#" + id).height($(this).height() * 0.96);
+                            $("#" + id).width($(this).width() * 0.96);
+                            plot.replot({ resetAxes: true });
+                        });
+                    },
+                    error: function (jqXHR, textStatus, errorThrown) {
+                        alert(textStatus);
+                        alert(errorThrown);
+                    }
+                });
+            }
+        });
+    });
+}
+
+function injectTableModifiers() {
+    // TODO: Make row add / delete via javascript
+    var i = 10 + 20;
+    return i;
 }
 
@@ -108,6 +255,6 @@
 
     try {
-        $(".collapsible").accordion("resize",
-        {
+        $(".collapsible").accordion({
+            heightStyle: "content",
             collapsible: true,
             active: false
@@ -131,37 +278,10 @@
             $(this).resizable();
         });
-
-        $(".matrix-graph").each(function (i) {
-            var tabable = $(this).closest(".tabable");
-            var id = this.id;
-            var resizerId = $(this).parent().get(0).id;
-            var indices = retrieveMatrix(id);
-
-            $.ajax({
-                url: '/Chart/GetMatrixContentForGraph?run=' + indices.runId + '&parameterOffset=' + indices.parameterOffset + "&showMarker=false",
-
-                success: function (result) {
-                    var plot = generatePlot(id, result);
-                    tabable.bind('tabsshow', function (event, ui) {
-                        if (ui.index == 1 && plot._drawCount == 0) {
-                            plot.replot();
-                        }
-                    });
-                    var resizer = $("#"+id).closest('.resizable');
-                    $(resizer).bind('resizestop', function (event, ui) {
-                        var id = $(this).children('div').get(0).id;
-                        $("#"+id).height($(this).height() * 0.96);
-                        $("#" + id).width($(this).width() * 0.96);
-                        plot.replot({ resetAxes: true });
-                    });
-                },
-                error: function (jqXHR, textStatus, errorThrown) {
-                    alert(textStatus);
-                    alert(errorThrown);
-                }
-            });
-        });
-    } catch (e) {
-    }
+    } catch (e) {
+    }
+
+    injectMatrixGraph();
+    injectDatatableAnalyzer();
+    //injectTableModifiers();
 }
 );
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/ChartController.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/ChartController.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/ChartController.cs	(revision 9166)
@@ -157,4 +157,83 @@
           return Json("error", JsonRequestBehavior.AllowGet);
         }
+
+        [HttpGet]
+        public JsonResult GetDatatableContent(string datatable, string datarow) {
+          try {
+            var model = Session["jobDetails"] as JobDetailsModel;
+            var plotableData = new PlotableData();
+
+            for (var i=0; i < model.Runs.Count; i++) {              
+              foreach (var result in model.Runs[i].Results) {
+                if (result.Value.Name == datatable) {
+                  var matrix = result.Value as DecimalMatrix;
+                  var index = Array.IndexOf(matrix.RowNames, datarow);
+                  plotableData.Series.Add(
+                    new SeriesEntry() {
+                      Label = "" + (i + 1) + ". Run - " + datatable + " - " + datarow,
+                      Values = matrix.Value[index]
+                    }
+                  );
+                  break;
+                }
+              }
+            }
+
+            return Json(plotableData, JsonRequestBehavior.AllowGet);
+          }
+          catch (Exception e) {
+            Trace.TraceError(e.Message);
+          }
+          Response.StatusCode = 400;
+          Response.Status = "Session timed out";
+          return Json("error", JsonRequestBehavior.AllowGet);
+        }
+
+        [HttpGet]
+        public JsonResult GetDatatables() {
+          try {
+            var model = Session["jobDetails"] as JobDetailsModel;
+            var dts = new DatatableContainer();
+            var datatables = new List<string>();
+            foreach (var param in model.Runs[0].Results) {
+              if (param.Value is DecimalMatrix) {
+                datatables.Add(param.Value.Name); 
+              }
+            }
+
+            dts.Datatables = datatables.ToArray();
+
+            return Json(dts, JsonRequestBehavior.AllowGet);
+          }
+          catch (Exception e) {
+            Trace.TraceError(e.Message);
+          }
+          Response.StatusCode = 400;
+          Response.Status = "Session timed out or ";
+          return Json("error", JsonRequestBehavior.AllowGet);
+        }
+
+        [HttpGet]
+        public JsonResult GetRowNames(string datatable) {
+          var model = Session["jobDetails"] as JobDetailsModel;
+          try {
+            foreach (var param in model.Runs[0].Results) {
+              if (param.Value.Name == datatable) {
+                var matrix = param.Value as DecimalMatrix;
+                
+                var rowNames = new RowNameContainer() {
+                  RowNames = new List<string>(matrix.RowNames)
+                };
+                return Json(rowNames, JsonRequestBehavior.AllowGet);                
+              }
+            }            
+          }
+          catch(Exception ex) {
+            Trace.WriteLine(ex.Message);
+          }
+          Response.StatusCode = 400;
+          Response.Status = "Session timed out";
+          return Json("error", JsonRequestBehavior.AllowGet);
+        }
     }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/OptimizationController.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/OptimizationController.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/OptimizationController.cs	(revision 9166)
@@ -10,4 +10,5 @@
 using System.Web.Security;
 using HeuristicLab.Services.Optimization.Web.Models;
+using HeuristicLab.Services.Optimization.ControllerService.General;
 
 namespace HeuristicLab.Services.Optimization.Web.Controllers
@@ -16,5 +17,5 @@
     public class OptimizationController : Controller
     {
-      public const string DEFAULT_CONTROLLER_ENDPOINT = "WSHttpBinding_IControllerService";
+      public static readonly string DEFAULT_CONTROLLER_ENDPOINT = Configuration.ControllerEndpointName;
 
       public delegate T ControllerServiceDelegate<T>(IControllerService service);
@@ -25,5 +26,5 @@
           Response.Redirect("/Account/Logon");
 
-        using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
+        using (var cf = new ChannelFactory<IControllerService>(DEFAULT_CONTROLLER_ENDPOINT)) {
           var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
           credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
@@ -38,5 +39,5 @@
           Response.Redirect("/Account/Logon");
 
-        using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {          
+        using (var cf = new ChannelFactory<IControllerService>(DEFAULT_CONTROLLER_ENDPOINT)) {          
           var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
           credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
@@ -66,5 +67,11 @@
           });
           Session["scenario"] = optScenario;
-          return View(optScenario.InputParameters);
+          if (optScenario.FirstAlgorithm.Problem == null)
+            return RedirectToAction("AlgorithmParameters");
+          return View(optScenario.FirstAlgorithm.Problem.Parameters);
+        }
+
+        public ActionResult ProblemParameters2() {                    
+          return View("ProblemParameters", (Session["scenario"] as OptimizationScenario).FirstAlgorithm.Problem.Parameters);
         }
 
@@ -93,5 +100,5 @@
 
         [HttpPost]
-        public ActionResult ProblemParameters(InputParameters parameters) {
+        public ActionResult ProblemParameters(ProblemParameters parameters) {
           if (ModelState.IsValid) {
             return RedirectToAction("AlgorithmParameters", parameters);
@@ -101,5 +108,5 @@
 
         public ActionResult AlgorithmParameters() {
-          return View((Session["scenario"] as OptimizationScenario).AlgorithmParameters);
+          return View((Session["scenario"] as OptimizationScenario).FirstAlgorithm.Parameters);
         }
 
@@ -117,5 +124,5 @@
 
         [HttpPost]
-        public ActionResult ScheduleJob(OptimizationScenario scenario) {
+        public ActionResult ScheduleJob(ScheduleJobModel jobModel) {
           using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
             var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
@@ -124,8 +131,36 @@
             var controllerProxy = cf.CreateChannel();
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
-            controllerProxy.ScheduleOptimizationScenario(u, Session["scenario"] as OptimizationScenario);
+            var scenario = Session["scenario"] as OptimizationScenario;
+            var details = new JobExecutionDetails() { Group = jobModel.Group, JobTitle = jobModel.Name, Repititions = jobModel.Repetitions };
+            controllerProxy.ScheduleOptimizationScenario(u, scenario, details);
           }
           return RedirectToAction("Index");
         }
+        // TODO: Add unique identifier for algorithm / input parameters
+        public ActionResult AddRow(int id, string paramName) {
+          var os = Session["scenario"] as OptimizationScenario;
+          var parameter = os.FirstAlgorithm.Problem.Parameters.FindByName(paramName);
+          bool inputParam = true;
+          if (parameter == null) {
+            parameter = os.FirstAlgorithm.Parameters.FindByName(paramName);
+            inputParam = false;
+          }
+          var dm = parameter.Value as DecimalMatrix;
+          dm.CopyRow(id);
+          return inputParam ? View("ProblemParameters", os.FirstAlgorithm.Problem.Parameters) : View("AlgorithmParameters", os.FirstAlgorithm.Parameters);
+        }
+
+        public ActionResult DeleteRow(int id, string paramName) {
+          var os = Session["scenario"] as OptimizationScenario;
+          var parameter = os.FirstAlgorithm.Problem.Parameters.FindByName(paramName);
+          bool inputParam = true;
+          if (parameter == null) {
+            parameter = os.FirstAlgorithm.Parameters.FindByName(paramName);
+            inputParam = false;
+          }
+          var dm = parameter.Value as DecimalMatrix;
+          dm.DeleteRow(id);
+          return inputParam ? View("ProblemParameters", os.FirstAlgorithm.Problem.Parameters) : View("AlgorithmParameters", os.FirstAlgorithm.Parameters);
+        }
     }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Global.asax.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Global.asax.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Global.asax.cs	(revision 9166)
@@ -32,5 +32,5 @@
       RegisterGlobalFilters(GlobalFilters.Filters);
       RegisterRoutes(RouteTable.Routes);
-      ModelBinders.Binders.Add(typeof(Optimization.ControllerService.Model.InputParameters), new ProblemParametersModelBinder());
+      ModelBinders.Binders.Add(typeof(Optimization.ControllerService.Model.ProblemParameters), new ProblemParametersModelBinder());
       ModelBinders.Binders.Add(typeof(Optimization.ControllerService.Model.AlgorithmParameters), new AlgorithmParametersModelBinder());
     }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 9166)
@@ -105,4 +105,5 @@
       <DependentUpon>Global.asax</DependentUpon>
     </Compile>
+    <Compile Include="Mockup\MockupMembershipProvider.cs" />
     <Compile Include="Models\AccountModels.cs" />
     <Compile Include="Models\AdminModels.cs" />
@@ -329,5 +330,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\InputParameters.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\ProblemParameters.cshtml" />
   </ItemGroup>
   <ItemGroup>
@@ -368,5 +369,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\InputParameters.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\ProblemParameters.cshtml" />
   </ItemGroup>
   <ItemGroup>
@@ -386,4 +387,5 @@
     <Content Include="Views\Chart\GenerateChart.cshtml" />
     <Content Include="Views\Optimization\Copy of JobDetails.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\StringValue.cshtml" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/benchmark.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/benchmark.cs	(revision 9166)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/benchmark.cs	(revision 9166)
@@ -0,0 +1,27 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Optimization;
+using HeuristicLab.Services.Optimization.ControllerService;
+using HeuristicLab.Algorithms.Benchmarks;
+using HeuristicLab.Parameters;
+using HeuristicLab.PluginInfrastructure;
+
+
+namespace HeuristicLab.Mappers {
+  public class BenchmarkScenarioMapper : IScenarioMapper {
+    public void MapScenario(OptimizationScenario scenario, out IAlgorithm algorithm) {
+      var alg = scenario.FirstAlgorithm;
+      var bm = new BenchmarkAlgorithm();
+      var bmFullName = HLMapper.GetStringValue(alg.Parameters.FindByName("Benchmark"));
+      bm.BenchmarkParameter.Value = bm.Benchmark = bm.BenchmarkParameter.ValidValues.First(b => b.GetType().FullName == bmFullName);      
+      ((ValueParameter<IntValue>)bm.Parameters["ChunkSize"]).Value = HLMapper.ConvertToIntValue(alg.Parameters.FindByName("ChunkSize"));
+      ((ValueParameter<DoubleValue>)bm.Parameters["TimeLimit"]).Value = HLMapper.ConvertToDoubleValue(alg.Parameters.FindByName("TimeLimit"));
+
+      algorithm = bm;
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/scenario.xsd
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/scenario.xsd	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/scenario.xsd	(revision 9166)
@@ -8,16 +8,28 @@
  <xsd:complexType name="scenarioType">
   <xsd:sequence maxOccurs="1">   
-   <xsd:element name="name" type="xsd:string"/>
-   <xsd:element name="problemParameters" type="paramsType"/>
-   <xsd:element name="algorithmParameters" type="paramsType"/>
-  </xsd:sequence>
-  <xsd:attribute name="problemType" use="required"/>
-  <xsd:attribute name="algorithmType" use="required"/>
-  <xsd:attribute name="mapper" use="required"/>
+   <xsd:element name="name" minOccurs="1" type="xsd:string"/>   
+   <xsd:element name="algorithm" minOccurs="1" maxOccurs="unbounded" type="algorithmType"/>   
+  </xsd:sequence>  
  </xsd:complexType>
+
+<xsd:complexType name="algorithmType">
+  <xsd:sequence maxOccurs="1">
+	<xsd:element name="parameters" type="paramsType"/>
+	<xsd:element name="problem" minOccurs="0" type="problemType"/>	
+	<xsd:element name="algorithm" minOccurs="0" maxOccurs="unbounded" type="algorithmType"/>		
+  </xsd:sequence>  
+  <xsd:attribute name="mapper" use="required"/>		
+</xsd:complexType>
+
+<xsd:complexType name="problemType">
+  <xsd:sequence maxOccurs="1">
+	<xsd:element name="parameters" type="paramsType"/>	
+  </xsd:sequence>  
+  <xsd:attribute name="class"/>	
+</xsd:complexType>
 
  <xsd:complexType name="paramsType">
   <xsd:sequence>
-   <xsd:element name="param" type="parameterType" minOccurs="1" maxOccurs="unbounded"/>      
+   <xsd:element name="param" type="parameterType" minOccurs="0" maxOccurs="unbounded"/>      
   </xsd:sequence>  
  </xsd:complexType>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/tsp.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/tsp.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/tsp.cs	(revision 9166)
@@ -4,39 +4,43 @@
 using System.Text;
 using HeuristicLab.Data;
-using HeuristicLab.Services.Optimization.ControllerService.Model; 
+using HeuristicLab.Services.Optimization.ControllerService.Model;
 using HeuristicLab.Optimization;
 using HeuristicLab.Services.Optimization.ControllerService;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
 using HeuristicLab.Problems.TravelingSalesman;
-public class TSPScenarioMapper : IScenarioMapper {
-  public void MapScenario(OptimizationScenario scenario, IAlgorithm algorithm) {
-    Console.WriteLine("Mapping scenario!");
-    var ga = algorithm as GeneticAlgorithm;
-    var problem = algorithm.Problem as TravelingSalesmanProblem;
-                  
-    problem.BestKnownQuality = HLMapper.ConvertToDoubleValue(scenario.InputParameters.FindByName("BestKnownQuality"));
-    problem.BestKnownSolution = HLMapper.ConvertToPermutation(scenario.InputParameters.FindByName("BestKnownSolution"));
-    problem.Coordinates = HLMapper.ConvertToDoubleMatrix(scenario.InputParameters.FindByName("Coordinates"));
-    var evalParam = HLMapper.GetStringValue(scenario.InputParameters.FindByName("EvaluatorParameter"));
-    if (evalParam == "HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator") {
-      problem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
+namespace HeuristicLab.Mappers {
+  public class TSPScenarioMapper : IScenarioMapper {
+    public void MapScenario(OptimizationScenario scenario, out IAlgorithm algorithm) {
+      Console.WriteLine("Mapping scenario!");
+      var ga = new GeneticAlgorithm();
+      var problem = new TravelingSalesmanProblem();
+      ga.Problem = problem;
+      algorithm = ga;
+
+      problem.BestKnownQuality = HLMapper.ConvertToDoubleValue(scenario.FirstAlgorithm.Problem.Parameters.FindByName("BestKnownQuality"));
+      problem.BestKnownSolution = HLMapper.ConvertToPermutation(scenario.FirstAlgorithm.Problem.Parameters.FindByName("BestKnownSolution"));
+      problem.Coordinates = HLMapper.ConvertToDoubleMatrix(scenario.FirstAlgorithm.Problem.Parameters.FindByName("Coordinates"));
+      var evalParam = HLMapper.GetStringValue(scenario.FirstAlgorithm.Problem.Parameters.FindByName("EvaluatorParameter"));
+      if (evalParam == "HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator") {
+        problem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
+      }
+      else if (evalParam == "HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator") {
+        problem.EvaluatorParameter.Value = new TSPGeoPathEvaluator();
+      }
+      else {
+        problem.EvaluatorParameter.Value = new TSPEuclideanPathEvaluator();
+      }
+      problem.UseDistanceMatrix = HLMapper.ConvertToBoolValue(scenario.FirstAlgorithm.Problem.Parameters.FindByName("UseDistanceMatrix"));
+      Console.WriteLine("Mapping algorithm...");
+      ga.Mutator = HLMapper.FindInItemSet<HeuristicLab.Optimization.IManipulator>(ga.MutatorParameter.ValidValues, scenario.FirstAlgorithm.Parameters.FindByName("Mutator"));
+      ga.CrossoverParameter.Value = HLMapper.FindOperator<HeuristicLab.Optimization.ICrossover>(problem, scenario.FirstAlgorithm.Parameters.FindByName("CrossoverParameter"));
+      ga.Elites = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName("Elites"));
+      ga.MaximumGenerations = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName("MaximumGenerations"));
+      ga.MutationProbability = HLMapper.ConvertToPercentValue(scenario.FirstAlgorithm.Parameters.FindByName("MutationProbability"));
+      ga.PopulationSize = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName("PopulationSize"));
+      ga.Seed = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName("Seed"));
+      ga.Selector = HLMapper.FindInItemSet<HeuristicLab.Optimization.ISelector>(ga.SelectorParameter.ValidValues, scenario.FirstAlgorithm.Parameters.FindByName("Selector"));
+      ga.SetSeedRandomly = HLMapper.ConvertToBoolValue(scenario.FirstAlgorithm.Parameters.FindByName("SetSeedRandomly"));
     }
-    else if (evalParam == "HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator") {
-      problem.EvaluatorParameter.Value = new TSPGeoPathEvaluator();
-    }
-    else {
-      problem.EvaluatorParameter.Value = new TSPEuclideanPathEvaluator();
-    }
-    problem.UseDistanceMatrix = HLMapper.ConvertToBoolValue(scenario.InputParameters.FindByName("UseDistanceMatrix"));
-    Console.WriteLine("Mapping algorithm...");
-    ga.Mutator = HLMapper.FindInItemSet<HeuristicLab.Optimization.IManipulator>(ga.MutatorParameter.ValidValues, scenario.AlgorithmParameters.FindByName("Mutator"));
-    ga.CrossoverParameter.Value = HLMapper.FindOperator<HeuristicLab.Optimization.ICrossover>(problem, scenario.AlgorithmParameters.FindByName("CrossoverParameter"));
-    ga.Elites = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("Elites"));
-    ga.MaximumGenerations = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("MaximumGenerations"));
-    ga.MutationProbability = HLMapper.ConvertToPercentValue(scenario.AlgorithmParameters.FindByName("MutationProbability"));                
-    ga.PopulationSize = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("PopulationSize"));
-    ga.Seed = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("Seed"));
-    ga.Selector = HLMapper.FindInItemSet<HeuristicLab.Optimization.ISelector>(ga.SelectorParameter.ValidValues, scenario.AlgorithmParameters.FindByName("Selector"));
-    ga.SetSeedRandomly = HLMapper.ConvertToBoolValue(scenario.AlgorithmParameters.FindByName("SetSeedRandomly"));
   }
 }
